package com.java8.Completable_Future;

import java.util.concurrent.CompletableFuture;
import java.util.concurrent.TimeUnit;

public class AsyncExample {

    public static void delay(int seconds) {
        try {
            TimeUnit.SECONDS.sleep(seconds);
        } catch (InterruptedException ex) {
            ex.printStackTrace();
        }
    }

    public static void main(String[] args) {

        Runnable runnable = () -> {
            delay(1000);
            System.out.println("Im in a Runnable : " + Thread.currentThread().getName());
        };

        // Crating CompletableFuture object
        CompletableFuture<Void> completableFuture = CompletableFuture.runAsync(runnable);
        System.out.println("I'm in main: " + Thread.currentThread().getName());

        // join method is used to wait for CompletableFuture to get complete
        completableFuture.join();
    }

}
